on Filtri___________________________
end

on InitFilters
  global gFilterAll, gFilterCopySkip, gFilterOn, gFilterType, gFilterCreat, gFilterOper, gFilterDate, gFilterScript
  set gFilterAll to 0
  set gFilterCopySkip to 1
  set gFilterScript to EMPTY
  set gFilterOn to []
  set gFilterType to []
  set gFilterCreat to []
  set gFilterOper to []
  set gFilterDate to []
  repeat with i = 1 to 7
    append(gFilterOn, 1)
    append(gFilterType, " ")
    append(gFilterCreat, " ")
    append(gFilterOper, " ")
    append(gFilterDate, " ")
  end repeat
  set the textHeight of member "fOnOffList" to 18
  set the textHeight of member "fTypeList" to 18
  set the textHeight of member "fCreatorList" to 18
  set the textHeight of member "fOperatorList" to 18
  set the textHeight of member "fDateList" to 18
end

on GoFilters
  global gFilterAll, gFilterCopySkip, gTempFilterAll, gTempFilterCopySkip, gFilterOn, gFilterType, gFilterCreat, gFilterOper, gFilterDate, gGrigio, gNero
  if voidp(gFilterAll) then
    set gFilterAll to 0
  end if
  set gTempFilterAll to gFilterAll
  if voidp(gFilterCopySkip) then
    set gFilterCopySkip to 1
  end if
  set gTempFilterCopySkip to gFilterCopySkip
  put EMPTY into field "fTypeList"
  put EMPTY into field "fCreatorList"
  put EMPTY into field "fOperatorList"
  put EMPTY into field "fDateList"
  set the foreColor of field "fOnOffList" to gNero
  set the foreColor of field "fTypeList" to gNero
  set the foreColor of field "fCreatorList" to gNero
  set the foreColor of field "fOperatorList" to gNero
  set the foreColor of field "fDateList" to gNero
  set tempType to EMPTY
  set tempCrea to EMPTY
  set tempOper to EMPTY
  set tempDate to EMPTY
  repeat with i = 1 to 7
    put getAt(gFilterType, i) & RETURN after tempType
    put getAt(gFilterCreat, i) & RETURN after tempCrea
    put getAt(gFilterOper, i) & RETURN after tempOper
    put getAt(gFilterDate, i) & RETURN after tempDate
  end repeat
  delete char -30000 of tempType
  delete char -30000 of tempCrea
  delete char -30000 of tempOper
  delete char -30000 of tempDate
  put tempType into field "fTypeList"
  put tempCrea into field "fCreatorList"
  put tempOper into field "fOperatorList"
  put tempDate into field "fDateList"
  repeat with i = 1 to 7
    if not getAt(gFilterOn, i) then
      set the foreColor of line i of field "fOnOffList" to gGrigio
      set the foreColor of line i of field "fTypeList" to gGrigio
      set the foreColor of line i of field "fCreatorList" to gGrigio
      set the foreColor of line i of field "fOperatorList" to gGrigio
      set the foreColor of line i of field "fDateList" to gGrigio
    end if
  end repeat
  go("Filters")
  SetMenuCredits()
end

on TastoFilters
  global gBianco, gNero
  if (the key = RETURN) or (charToNum(the key) = 3) then
    set mySprite to 39
  else
    if the keyCode = 53 then
      set mySprite to 36
    else
      exit
    end if
  end if
  set myBtnUp to the name of member the member of sprite mySprite
  set myTextMember to the member of sprite (mySprite + 1)
  set the member of sprite mySprite to BtnDw(myBtnUp)
  set the forecolor of myTextMember to gBianco
  updateStage()
  repeat with i = 0 to 15000
  end repeat
  set the member of sprite mySprite to myBtnUp
  set the foreColor of member myTextMember to gNero
  updateStage()
  if mySprite = 39 then
    ApplyFiltri()
  else
    if mySprite = 36 then
      GoLista()
    end if
  end if
end

on SetOneFilterOnOff myLinea
  global gGrigio, gNero
  set a to the foreColor of char 1 of line myLinea of field "fOnOffList" = gNero
  set a to not a
  if a then
    set colore to gNero
  else
    set colore to gGrigio
  end if
  set the foreColor of char 1 of line myLinea of field "fOnOffList" to colore
  set the foreColor of line myLinea of field "fTypeList" to colore
  set the foreColor of line myLinea of field "fCreatorList" to colore
  set the foreColor of line myLinea of field "fOperatorList" to colore
  set the foreColor of line myLinea of field "fDateList" to colore
end

on AskForType myLinea
  if the optionDown then
    put " " into line myLinea of field "fTypeList"
  else
    set myFile to DisplayOpenMyFile()
    if myFile <> EMPTY then
      set myType to GetType(myFile)
      put myType into line myLinea of field "fTypeList"
    end if
  end if
end

on AskForCreator myLinea
  if the optionDown then
    put " " into line myLinea of field "fCreatorList"
  else
    set myFile to DisplayOpenMyFile()
    if myFile <> EMPTY then
      set myCreator to GetCreator(myFile)
      put myCreator into line myLinea of field "fCreatorList"
    end if
  end if
end

on AskForTypeAndCreator myLinea
  if the optionDown then
    put " " into line myLinea of field "fTypeList"
    put " " into line myLinea of field "fCreatorList"
  else
    set myFile to DisplayOpenMyFile()
    if myFile <> EMPTY then
      set myType to GetType(myFile)
      set myCreator to GetCreator(myFile)
      put myType into line myLinea of field "fTypeList"
      put myCreator into line myLinea of field "fCreatorList"
    end if
  end if
end

on AskForOperatorList myLinea
  set myChar to line myLinea of field "fOperatorList"
  if the optionDown then
    put " " into line myLinea of field "fOperatorList"
    put " " into line myLinea of field "fDateList"
  else
    case myChar of
      " ":
        set k to ">"
      ">=":
        set k to ">"
      ">":
        set k to "="
      "=":
        set k to "<"
      "<":
        set k to "<="
      "<=":
        set k to ">="
    end case
    put k into line myLinea of field "fOperatorList"
  end if
end

on AskForDate myLinea
  if the optionDown then
    put " " into line myLinea of field "fOperatorList"
    put " " into line myLinea of field "fDateList"
  else
    OpenDateWind(myLinea)
  end if
end

on ImportFilterDate myLinea
  global gDay, gMonth, gYear
  if length(gDay) = 1 then
    put "0" before gDay
  end if
  set gMonth to MeseCorto(value(gMonth))
  if length(gYear) = 2 then
    put Sinistra(TodayYear(1), 2) before gYear
  end if
  set myDate to gDay && gMonth && gYear
  put myDate into line myLinea of field "fDateList"
  if line myLinea of field "fOperatorList" = " " then
    put ">=" into line myLinea of field "fOperatorList"
  end if
end

on SetCheckBox myVariable, mySprite, myRoll
  case myVariable of
    "gFilterAll":
      BtnFilterAll(mySprite, myRoll)
    "gOneDirection":
      BtnCHKDirection(mySprite, myRoll)
    "gDestructive":
      BtnChK(mySprite, myRoll, myVariable)
    "gInvisible":
      BtnChK(mySprite, myRoll, myVariable)
    "gUnlockFile":
      BtnChK(mySprite, myRoll, myVariable)
    "gAskConfirm":
      BtnChK(mySprite, myRoll, myVariable)
    "gRememberFolders":
      BtnChK(mySprite, myRoll, myVariable)
    "gBeepWhenDone":
      BtnChK(mySprite, myRoll, myVariable)
    "gSaveLogFile":
      BtnChK(mySprite, myRoll, myVariable)
    "gTempDoAndQuit":
      BtnChK(mySprite, myRoll, myVariable)
    "gTempMultiAll":
      BtnChK(mySprite, myRoll, myVariable)
      SetIngrigisceMulti()
    "gTempTimerAll":
      BtnChK(mySprite, myRoll, myVariable)
      SetIngrigisceTimer()
    "gRememberMultiList":
      BtnChK(mySprite, myRoll, myVariable)
    "gTempTimerWhenNeeded":
      BtnChK(mySprite, myRoll, myVariable)
    "gTempRememberTimer":
      BtnChK(mySprite, myRoll, myVariable)
  end case
end

on BtnFilterAll mySprite, myRoll
  global gTempFilterAll
  set myBtnUp to the name of member the member of sprite mySprite
  set myValue to value(the last char in myBtnUp)
  repeat while the stillDown
    if the rollOver = myRoll then
      set the member of sprite mySprite to BtnDw(myBtnUp)
    else
      set the member of sprite mySprite to myBtnUp
    end if
    updateStage()
  end repeat
  set the member of sprite mySprite to myBtnUp
  updateStage()
  if the rollOver = myRoll then
    set gTempFilterAll to not gTempFilterAll
    put char 1 of string(gTempFilterAll) into char length(myBtnUp) of myBtnUp
  end if
  set the member of sprite mySprite to myBtnUp
  set myPoint to point(the left of sprite 17 + 1, the top of sprite 17 + 1)
  if not gTempFilterAll then
    set the loc of sprite 100 to myPoint
  else
    set the locV of sprite 100 to -1000
  end if
  updateStage()
end

on BtnCopySkip mySprite, myRoll, myRadio
  global gTempFilterCopySkip
  set myBtnUp to the name of member the member of sprite mySprite
  set myValue to value(the last char in myBtnUp)
  if myRadio = "Copy" then
    set deltaSprite to 2
  else
    set deltaSprite to -2
  end if
  repeat while the stillDown
    if the rollOver = myRoll then
      set the member of sprite mySprite to BtnDw(myBtnUp)
    else
      set the member of sprite mySprite to myBtnUp
    end if
    updateStage()
  end repeat
  set the member of sprite mySprite to myBtnUp
  updateStage()
  if myValue = 1 then
    exit
  end if
  if the rollOver = myRoll then
    set gTempFilterCopySkip to not gTempFilterCopySkip
    put "0" into char length(myBtnUp) of myBtnUp
    set the member of sprite (mySprite + deltaSprite) to myBtnUp
    put "1" into char length(myBtnUp) of myBtnUp
  end if
  set the member of sprite mySprite to myBtnUp
  updateStage()
end

on ApplyFiltri
  global gFilterOn, gFilterType, gFilterCreat, gFilterOper, gFilterDate, gFilterAll, gFilterCopySkip, gTempFilterAll, gTempFilterCopySkip, gNero
  set gFilterAll to gTempFilterAll
  set gFilterCopySkip to gTempFilterCopySkip
  repeat with i = 1 to 7
    if the foreColor of line i of field "fOnOffList" = gNero then
      setAt(gFilterOn, i, 1)
    else
      setAt(gFilterOn, i, 0)
    end if
    setAt(gFilterType, i, line i of field "fTypeList")
    setAt(gFilterCreat, i, line i of field "fCreatorList")
    setAt(gFilterOper, i, line i of field "fOperatorList")
    setAt(gFilterDate, i, line i of field "fDateList")
  end repeat
  GoLista()
end

on AskDeleteAllFilters
  DialogBoxSiNo("Would you delete all the filters?", "DeleteAllFilters", "nothing")
end

on DeleteAllFilters
  global gNero, gGrigio
  updateStage()
  set stringa to " " & RETURN & " " & RETURN & " " & RETURN & " " & RETURN & " " & RETURN & " " & RETURN & " "
  put stringa into field "fTypeList"
  put stringa into field "fCreatorList"
  put stringa into field "fOperatorList"
  put stringa into field "fDateList"
  set the foreColor of field "fOnOffList" to gNero
  set the foreColor of field "fTypeList" to gNero
  set the foreColor of field "fCreatorList" to gNero
  set the foreColor of field "fOperatorList" to gNero
  set the foreColor of field "fDateList" to gNero
end

on CompactFilters
  global gFilterAll, gFilterCopySkip, gFilterOn, gFilterType, gFilterCreat, gFilterOper, gFilterDate, myCompactType, myCompactCreat, myCompactOper, myCompactDate, gFilterScript, gFilterTextLog, gNumFilters
  set gFilterTextLog to EMPTY
  if not gFilterAll then
    exit
  end if
  set gNumFilters to 0
  set myFilter to EMPTY
  set myOr to EMPTY
  repeat with i = 1 to 7
    if getAt(gFilterOn, i) then
      if (getAt(gFilterType, i) <> " ") or (getAt(gFilterCreat, i) <> " ") or (getAt(gFilterDate, i) <> " ") then
        set gNumFilters to gNumFilters + 1
        put "Filter" && i && "-" after gFilterTextLog
        put myOr & "(" after myFilter
        set myAnd to EMPTY
        if getAt(gFilterType, i) <> " " then
          put " Type:" && getAt(gFilterType, i) & "," after gFilterTextLog
          set myFilter to myFilter && "myType = " & QUOTE & getAt(gFilterType, i) & QUOTE
          set myAnd to "and "
        end if
        if getAt(gFilterCreat, i) <> " " then
          put " Creator:" && getAt(gFilterCreat, i) & "," after gFilterTextLog
          set myFilter to myFilter && myAnd & "myCreat = " & QUOTE & getAt(gFilterCreat, i) & QUOTE
          set myAnd to "and "
        end if
        if getAt(gFilterDate, i) <> " " then
          put " Date:" && getAt(gFilterOper, i) & getAt(gFilterDate, i) & "," after gFilterTextLog
          set myData to CustomData(getAt(gFilterDate, i))
          set myFilter to myFilter && myAnd & "FiltraDate(myFile, " & QUOTE & getAt(gFilterOper, i) & QUOTE & "," && QUOTE & myData & QUOTE & ")"
        end if
        delete char -30000 of gFilterTextLog
        put RETURN after gFilterTextLog
        put ")" after myFilter
        set myOr to " or "
      end if
    end if
  end repeat
  if gNumFilters > 0 then
    put "Filters Mode: " & CopySkip(gFilterCopySkip) & RETURN before gFilterTextLog
    put "Filters Applied: " & gNumFilters & RETURN before gFilterTextLog
    put "--" & RETURN after gFilterTextLog
  end if
  set gFilterScript to myFilter
end

on CopySkip Valore
  if Valore then
    return "Copy Only"
  else
    return "Skip Only"
  end if
end

on FilterThis myFile
  global gFilterScript, gFilterCopySkip
  set myType to GetType(myFile)
  set myCreat to GetCreator(myFile)
  if value(gFilterScript) = gFilterCopySkip then
    return 1
  end if
  return 0
end

on FiltraDate destF, oper, myDateB
  set a to OSFileModify(destF)
  set oldDelimiter to the itemDelimiter
  set the itemDelimiter to ","
  set myDateA to item 1 of a
  set the itemDelimiter to "/"
  set myYearA to value(item 1 of myDateA)
  set myMonthA to value(item 2 of myDateA)
  set myDayA to value(item 3 of myDateA)
  set myYearB to value(item 1 of myDateB)
  set myMonthB to value(item 2 of myDateB)
  set myDayB to value(item 3 of myDateB)
  set the itemDelimiter to oldDelimiter
  set TotGiorniA to DaysAnnoZero(myYearA, myMonthA, myDayA)
  set TotGiorniB to DaysAnnoZero(myYearB, myMonthB, myDayB)
  if value(TotGiorniA & oper & TotGiorniB) then
    return 1
  else
    return 0
  end if
end

on DaysAnnoZero anno, mese, giorno
  if anno > 0 then
    set Ybis to ((anno - 1) / 4) + 1
    set Ynor to anno - 1 - Ybis + 1
    set DayA to (366 * Ybis) + (365 * Ynor)
  else
    set DayA to 0
  end if
  case mese of
    1:
      set DayM to 0
    2:
      set DayM to 31
    3:
      set DayM to 59
    4:
      set DayM to 90
    5:
      set DayM to 120
    6:
      set DayM to 151
    7:
      set DayM to 181
    8:
      set DayM to 212
    9:
      set DayM to 243
    10:
      set DayM to 273
    11:
      set DayM to 304
    12:
      set DayM to 334
  end case
  if ((anno mod 4) = 0) and (mese > 2) then
    set DayM to DayM + 1
  end if
  return DayA + DayM + giorno
end

on CustomData exData
  set oldDelimiter to the itemDelimiter
  set the itemDelimiter to " "
  set giorno to value(item 1 of exData)
  set mese to MeseNum(item 2 of exData)
  set anno to value(item 3 of exData)
  set the itemDelimiter to oldDelimiter
  return anno & "/" & mese & "/" & giorno
end
