on HideProgressBar
  set the locV of sprite 8 to 142
  set the locV of sprite 3 to -1000
  set the locV of sprite 4 to -1000
  updateStage()
end

on ShowProgressBar
  put " " into field "fItems"
  put "Stop" into field "P4"
  set the locV of sprite 8 to -1000
  set the loc of sprite 2 to point(147, 150)
  updateStage()
end

on HideInfiniteProgressBar
  set the locV of sprite 2 to -1000
  updateStage()
end

on SetFooterLogFile
  global gSourceFolder, gSourceFolderList, gSourceFileList, gAFoldersCreated, gAFilesReplaced, gAFilesCopied, gAFilesRenamed, gDestFolder, gDestFolderList, gDestFileList, gBFoldersCreated, gBFilesReplaced, gBFilesCopied, gBFilesRenamed, gOneDirection, gDestructive, gTotError
  set TextReport to EMPTY
  put "End at:" && the long date && "-" && the long time & RETURN & RETURN after TextReport
  put "Summary:" & RETURN after TextReport
  put "•" && gSourceFolder & RETURN after TextReport
  put "Folders Found:" && string(count(gSourceFolderList)) & RETURN after TextReport
  put "Files Found:" && string(count(gSourceFileList)) & RETURN & "-" & RETURN after TextReport
  put "Folders Created:" && string(gAFoldersCreated) & RETURN after TextReport
  put "Files Replaced:" && string(gAFilesReplaced) & RETURN after TextReport
  put "Files Copied (new additions) :" && string(gAFilesCopied) & RETURN after TextReport
  put "Files Renamed (to avoid FolderNames conflicts) :" && string(gAFilesRenamed) & RETURN & RETURN after TextReport
  put "•" && gDestFolder & RETURN after TextReport
  put "Folders Found:" && string(count(gDestFolderList)) & RETURN after TextReport
  put "Files Found:" && string(count(gDestFileList)) & RETURN & "-" & RETURN after TextReport
  put "Folders Created:" && string(gBFoldersCreated) & RETURN after TextReport
  put "Files Replaced:" && string(gBFilesReplaced) & RETURN after TextReport
  put "Files Copied (new additions) :" && string(gBFilesCopied) & RETURN after TextReport
  put "Files Renamed (to avoid FolderNames conflicts) :" && string(gBFilesRenamed) & RETURN after TextReport
  if gOneDirection and gDestructive then
    put "Files Deleted:" && string(gTotErasedFiles) & RETURN after TextReport
    put "Folders Deleted:" && string(gTotErasedFolders) & RETURN after TextReport
  end if
  put RETURN & "• Errors:" && string(gTotError) after TextReport
  return TextReport
end
